package test.jbpm.service;

import org.drools.event.process.DefaultProcessEventListener;
import org.drools.event.process.ProcessCompletedEvent;
import org.drools.event.process.ProcessStartedEvent;

public class CMTProcessEventListener extends DefaultProcessEventListener {
	
	private String caller = "";
	private long processInstanceId = -1;
	private boolean isProcessCompleted = false;
	
	public CMTProcessEventListener(long processInstanceId,String caller)
	{
		this.caller = caller;
		this.processInstanceId = processInstanceId;
	}

	
	@Override
	public void beforeProcessStarted(ProcessStartedEvent event) {
		System.out.println(">>> CMTProcessEventListener, "+caller+" beforeProcessStarted...");
	}
	
	@Override
	public void afterProcessStarted(ProcessStartedEvent event) {
		System.out.println(">>> CMTProcessEventListener, "+caller+" afterProcessStarted...");
	}
	
	@Override
	public void beforeProcessCompleted(ProcessCompletedEvent event) {
		System.out.println(">>> CMTProcessEventListener, "+caller+" beforeProcessCompleted...");
	}
	
	@Override
	public void afterProcessCompleted(ProcessCompletedEvent event) {
		System.out.println(">>> CMTProcessEventListener, "+caller+" afterProcessCompleted invoked...");

		try {
			synchronized(this)
			{
				this.isProcessCompleted = true;
			}
			
		} catch (Throwable e) {
			System.out.println(">>> CMTProcessEventListener, "+caller+" afterProcessCompleted exception: "+e);
		}
	}
	
	public boolean isProcessCompleted()
	{
		return isProcessCompleted;
	}

}
